----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:21:21 08/24/2016 
-- Design Name: 
-- Module Name:    gray_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity gray_counter is
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           q : out  STD_LOGIC_VECTOR (3 downto 0));
end gray_counter;

architecture Behavioral of gray_counter is
signal b : std_logic_vector(3 downto 0) := x"1";
signal g : std_logic_vector(3 downto 0) := x"0";
begin
q <= g;
process(clk)
begin
	if(clk'event and clk = '1')then
		if(reset = '1')then
			b <= x"1";
			g <= x"0";
		else
			b <= b + 1;
			g <= b xor ('0' & b(3 downto 1));
		end if;
	end if;
end process;

end Behavioral;

