----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:00:08 02/12/2016 
-- Design Name: 
-- Module Name:    rom - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity rom is
    Port ( ttc_clk : in  STD_LOGIC;
           tp_a : in  STD_LOGIC_VECTOR (23 downto 0);
           tp_b : in  STD_LOGIC_VECTOR (23 downto 0);
           addr : in  STD_LOGIC_VECTOR (7 downto 0);
           gol0 : out  STD_LOGIC_VECTOR (23 downto 0);
           gol1 : out  STD_LOGIC_VECTOR (23 downto 0);
           gol2 : out  STD_LOGIC_VECTOR (23 downto 0));
end rom;

architecture Behavioral of rom is
COMPONENT m32_1
	PORT(
		d : IN std_logic_vector(31 downto 0);
		s : IN std_logic_vector(4 downto 0);          
		o : OUT std_logic
		);
END COMPONENT;
COMPONENT m16_1
	PORT(
		d : IN std_logic_vector(15 downto 0);
		s : IN std_logic_vector(3 downto 0);          
		o : OUT std_logic
		);
END COMPONENT;
signal s : std_logic_vector(431 downto 0) := (others => '0');
signal data : std_logic_vector(71 downto 0) := (others => '0');
signal lut_addr : std_logic_vector(8 downto 0) := (others => '0');
signal lut_addrb : std_logic_vector(8 downto 0) := (others => '0');
signal data_a : std_logic_vector(71 downto 0) := (others => '0');
signal data_b : std_logic_vector(71 downto 0) := (others => '0');
signal mux_in_a : std_logic_vector(31 downto 0) := (others => '0');
signal mux_in_b : std_logic_vector(15 downto 0) := (others => '0');
begin
gol0 <= data(23 downto 0);
gol1 <= data(47 downto 24);
gol2 <= data(71 downto 48);
i_rom0: RAMB16_S36_S36
generic map(
INIT_00  => X"58687188440C0042FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_01  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_02  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_03  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_04  => X"FFFFFFFFFFFFFFFFCA247188440C100258687188440C100258687188440C0042",
INITP_00 => X"FFFFFFFFFFFFFFFFFFFFFFFFFF216161FFFFFFFFFFFFFFFFFFFFFFFF61FFFFFF"
)
		   port map(
			   dia => x"00000000",
				dib => x"00000000",
				dipa => x"0",
				dipb => x"0",
				ena => '1',
				enb => '1',
				wea => '0',
				web => '0',
				ssra => '0',
				ssrb => '0',
				clka => ttc_clk,
				clkb => ttc_clk,
				addra => lut_addr,
				addrb => lut_addrb,
				doa => s(31 downto 0),
				dopa => s(35 downto 32),
				dob => s(67 downto 36),
				dopb => s(71 downto 68)
				);
i_rom1: RAMB16_S36_S36
generic map(
INIT_00  => X"FFFFFFFFDE81D71BFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_01  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_02  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_03  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_04  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFCD30EFFFFFFFFDE81D71BFFFFFFFFDE81D71B",
INITP_00 => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7FFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFF"
)
		   port map(
			   dia => x"00000000",
				dib => x"00000000",
				dipa => x"0",
				dipb => x"0",
				ena => '1',
				enb => '1',
				wea => '0',
				web => '0',
				ssra => '0',
				ssrb => '0',
				clka => ttc_clk,
				clkb => ttc_clk,
				addra => lut_addr,
				addrb => lut_addrb,
				doa => s(103 downto 72),
				dopa => s(107 downto 104),
				dob => s(139 downto 108),
				dopb => s(143 downto 140)
				);
i_rom2: RAMB16_S36_S36
generic map(
INIT_00  => X"9351240F4E30A2C9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_01  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_02  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_03  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_04  => X"FFFFFFFFFFFFFFFFE285F7A05C6D961A955D24D44F38C2C99351240F4C34A2C9",
INITP_00 => X"FFFFFFFFFFFFFFFFFFFFFFFFFF875454FFFFFFFFFFFFFFFFFFFFFFFF53FFFFFF"
)
		   port map(
			   dia => x"00000000",
				dib => x"00000000",
				dipa => x"0",
				dipb => x"0",
				ena => '1',
				enb => '1',
				wea => '0',
				web => '0',
				ssra => '0',
				ssrb => '0',
				clka => ttc_clk,
				clkb => ttc_clk,
				addra => lut_addr,
				addrb => lut_addrb,
				doa => s(175 downto 144),
				dopa => s(179 downto 176),
				dob => s(211 downto 180),
				dopb => s(215 downto 212)
				);
i_rom3: RAMB16_S36_S36
generic map(
INIT_00  => X"EAA299E5A48A15D5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_01  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_02  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_03  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_04  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFE5926EAB27A29649A18A3EAB27A25A48A18D5",
INITP_00 => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFA9A9FFFFFFFFFFFFFFFFFFFFFFFFA9FFFFFF"
)
		   port map(
			   dia => x"00000000",
				dib => x"00000000",
				dipa => x"0",
				dipb => x"0",
				ena => '1',
				enb => '1',
				wea => '0',
				web => '0',
				ssra => '0',
				ssrb => '0',
				clka => ttc_clk,
				clkb => ttc_clk,
				addra => lut_addr,
				addrb => lut_addrb,
				doa => s(247 downto 216),
				dopa => s(251 downto 248),
				dob => s(283 downto 252),
				dopb => s(287 downto 284)
				);
i_rom4: RAMB16_S36_S36
generic map(
INIT_00  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_01  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_02  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_03  => X"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INIT_04  => X"FFFFFFFFFFFFFFFF27A57595D25103D1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",
INITP_00 => X"FFFFFFFFFFFFFFFFFFFFFFFFFFA4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF"
)
		   port map(
			   dia => x"00000000",
				dib => x"00000000",
				dipa => x"0",
				dipb => x"0",
				ena => '1',
				enb => '1',
				wea => '0',
				web => '0',
				ssra => '0',
				ssrb => '0',
				clka => ttc_clk,
				clkb => ttc_clk,
				addra => lut_addr,
				addrb => lut_addrb,
				doa => s(319 downto 288),
				dopa => s(323 downto 320),
				dob => s(355 downto 324),
				dopb => s(359 downto 356)
				);
i_rom5: RAMB16_S36_S36
generic map(
INIT_00  => X"0000000000000000000000000000000000000000000000000000000000000000",
INIT_01  => X"0000000000000000000000000000000000000000000000000000000000000000",
INIT_02  => X"0000000000000000000000000000000000000000000000000000000000000000",
INIT_03  => X"0000000000000000000000000000000000000000000000000000000000000000",
INIT_04  => X"FFFFFFFFFFFFFFFF00000000EEB6BAAC00000000000000000000000000000000",
INITP_00 => X"FFFFFFFFFFFFFFFFFFFFFFFFFF0B000000000000000000000000000000000000"
)
		   port map(
			   dia => x"00000000",
				dib => x"00000000",
				dipa => x"0",
				dipb => x"0",
				ena => '1',
				enb => '1',
				wea => '0',
				web => '0',
				ssra => '0',
				ssrb => '0',
				clka => ttc_clk,
				clkb => ttc_clk,
				addra => lut_addr,
				addrb => lut_addrb,
				doa => s(391 downto 360),
				dopa => s(395 downto 392),
				dob => s(427 downto 396),
				dopb => s(431 downto 428)
				);
lut_addr <= addr & '0';
lut_addrb <= addr & '1';
i_g0: for i in 0 to 71 generate
    i_mux_a: m32_1 PORT MAP(
									d =>  mux_in_a,
									s => s(4+i*6 downto i*6),
									o => data_a(i));
    i_mux_ba: m16_1 PORT MAP(
									d => mux_in_b,
									s => s(3+i*6 downto i*6),
									o => data_b(i));
	data(i) <= (not s(5+i*6) and data_a(i)) or (s(5+i*6) and not s(4+i*6) and data_b(i));	
end generate;
mux_in_a <= TP_b(7 downto 0) & TP_a(23 downto 0); 
mux_in_b <= TP_b(23 downto 8);


end Behavioral;

