--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   18:59:37 03/02/2017
-- Design Name:   
-- Module Name:   D:/iseproj/oslbRPC/sender.vhd
-- Project Name:  oslbvc
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: rpc_sender
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY sender IS
END sender;
 
ARCHITECTURE behavior OF sender IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT rpc_sender
    PORT(
         resetN : IN  std_logic;
         clock : IN  std_logic;
         part_ena : IN  std_logic;
         check_ena : IN  std_logic;
         check_data : IN  std_logic_vector(7 downto 0);
         check_data_ena : IN  std_logic;
         in_data : IN  std_logic_vector(23 downto 0);
         out_data : OUT  std_logic_vector(31 downto 0);
         test_data : IN  std_logic_vector(31 downto 0);
         test_ena : IN  std_logic;
         test_rand_ena : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal resetN : std_logic := '0';
   signal clock : std_logic := '0';
   signal toggle : std_logic := '0';
   signal clock4x : std_logic := '1';
   signal part_ena : std_logic := '0';
   signal check_ena : std_logic := '0';
   signal check_data : std_logic_vector(7 downto 0) := (others => '0');
   signal check_data_ena : std_logic := '1';
   signal in_data : std_logic_vector(23 downto 0) := x"123456";
   signal test_data : std_logic_vector(31 downto 0) := (others => '0');
   signal strobe : std_logic_vector(5 downto 0) := (others => '0');
   signal toggle_q : std_logic_vector(3 downto 0) := (others => '0');
   signal edge : std_logic_vector(3 downto 0) := (others => '0');
   signal test_ena : std_logic := '0';
   signal test_rand_ena : std_logic := '0';

 	--Outputs
   signal out_data : std_logic_vector(31 downto 0);

   -- Clock period definitions
   constant clock_period : time := 10 ns;
   signal test_datap : std_logic_vector(23 downto 0);
 
BEGIN
process(clock,resetN)
begin
	if(resetN = '0')then
		check_data <= (others => '0');
		test_datap <= (others => '0');
		toggle <= '0';
	elsif(clock'event and clock = '1')then
		check_data <= check_data + 1;
	  test_datap <= test_datap(22 downto 0) & not(test_datap(23) xor test_datap(22) xor test_datap(21) xor test_datap(16));
		toggle <= not toggle;
	end if;
end process; 
	-- Instantiate the Unit Under Test (UUT)
   uut: rpc_sender PORT MAP (
          resetN => resetN,
          clock => clock,
          part_ena => part_ena,
          check_ena => check_ena,
          check_data => check_data,
          check_data_ena => check_data_ena,
          in_data => in_data,
          out_data => out_data,
          test_data => test_data,
          test_ena => test_ena,
          test_rand_ena => test_rand_ena
        );

   -- Clock process definitions
   clock_process :process
   begin
		clock <= '0';
		wait for clock_period/2;
		clock <= '1';
		wait for clock_period/2;
   end process;
clock4x <= not clock4x after 1.25ns; 
process(clock4x)
begin
	if(clock4x'event and clock4x = '1')then
		strobe(0) <= not strobe(0);
		strobe(1) <= strobe(1) xor strobe(0);
	  strobe(5 downto 2) <= strobe(4 downto 2) & (strobe(0) and not strobe(1));
		for i in 0 to 3 loop
			if(strobe(i+2) = '1')then
				toggle_q(i) <= toggle;
			end if;
		end loop;
		if(strobe(2) = '1')then
			edge <= toggle_q;
		end if;
	end if;
end process; 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clock_period*10;
resetN <= '1';
      -- insert stimulus here 

      wait;
   end process;

END;
